#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define NMax 17

int n;
int p[NMax][4]; // p[i] = culorile patratului i in ordine
int query; // tipul de cerinta

int o[NMax][NMax]; // ornamentul
int uz[NMax]; // daca am folosit sau nu patratul i
int ways; // numarul de posibilitati

void bkt(int l, int c) {
	if (l > n) {
		if (query == 2) {
			ways ++;
		} else {
			for (int i = 1; i <= n; i++) {
				for (int j = 1; j <= n; j++) {
					printf("%d ", o[i][j]);
				}
				printf("\n");
			}
			fclose(stdout);
			exit(0);
		}
	} else {
		for (o[l][c] = 1; o[l][c] <= n * n; o[l][c]++) if (uz[o[l][c]] == 0) { // orice patrat nefolosit
			if ((p[o[l - 1][c]][2] == 0 || p[o[l - 1][c]][2] == p[o[l][c]][0]) && // daca se potrivesc culorile sus si in stanga
		        (p[o[l][c - 1]][1] == 0 || p[o[l][c - 1]][1] == p[o[l][c]][3])) {

			    uz[o[l][c]] = 1;
				bkt(l + (c == n), c + (c != n) + (c == n) * (1 - c)); // sar la pozitia urmatoare
				uz[o[l][c]] = 0;
			}
		}
	}
}

int main() {
	freopen("ornament.in", "r", stdin);
	freopen("ornament.out", "w", stdout);

	scanf("%d", &n);
	n = (int) sqrt((double)n);
	for (int i = 1; i <= n * n; i++) {
		for (int j = 0; j < 4; j++) {
			scanf("%d", &p[i][j]);
		}
	}
	scanf("%d", &query);

	bkt(1, 1);

	printf("%d\n", ways);
	fclose(stdout);
	return 0;
}