#include <stdio.h>
#define NMaxPomi 100005

FILE *fin = fopen("piscina.in", "rt");
FILE *fout = fopen("piscina.out", "wt");

int n;                            //numarul de pomi
int x[NMaxPomi], y[NMaxPomi];   //coordonatele pomilor
int Lp, Hp, Amax, lmax, hmax, xmax, ymax;

void Citire()
{
   int i;
   fscanf(fin, "%ld %ld %ld\n", &Lp, &Hp, &n);
   
   for (i = 0; i < n; i++)
	fscanf(fin, "%ld %ld", &x[i], &y[i]);   
}

int Interior(int i, int xs, int ys, int l, int h)
{
    /*intoarce 1 daca pomul i este in interiorul dreptunghiu-
    lui cu coltul stanga jos (xs
      },ys), lungime l si inaltime h*/
    if ((x[i]>xs) && (x[i]<xs+l) && (y[i]>ys) && (y[i]<ys+h))
        return 1;
    return 0;
}

int AreColt(int xs, int ys, int l, int h)
{
   //intoarce 1 daca piscina are un colt comun cu gradina
   if (xs == 0 && ys == 0) return 1;
   if (xs == 0 && ys + h == Hp) return 1;
   if (xs + l == Lp && ys == 0) return 1;
   if (xs + l == Lp && ys + h == Hp) return 1;
   return 0;
}

void Taie(int xs, int ys, int l, int h)
{
	//if (!AreColt(xs,ys,l,h)) {
		//return;
	//}
	//if ((int) l * h <= Amax) {
		//return;
	//}
   int i = 0;
   //caut un pom in gradina
   while ((i<n) && !Interior(i, xs, ys, l, h)) i++;
   if (i == n)     //zona nu are pomi
   {
      if ((int) l * h > Amax && AreColt(xs, ys, l, h))
      {
         Amax = (int) l * h;
         lmax = l;
         hmax = h;
         xmax = xs;
         ymax = ys;
      }
   }
   else                         //taiem "gradina" "prin" pomul i
   {
		   Taie(xs, ys, l, y[i] - ys);                //orizontal
		   Taie(xs, y[i], l,  ys + h - y[i]);
		   Taie(xs, ys, x[i]-xs, h);                  //vertical
		   Taie(x[i], ys, xs + l - x[i], h);
   }
}

int main()
{
   Citire();
   Taie(0, 0, Lp, Hp);
//    cout << "Piscina de arie maxima are coltul stanga jos (";
//    cout << xmax << ", " << ymax<< ")\n";
//    cout << "Lungimea = " << lmax << "; inaltimea = " << hmax << '\n';
   //fout << Amax << '\n';
   fprintf(fout, "%ld\n", Amax);
   fclose(fout);
   return 0;
}
